import{s as Ae,n as Ie,o as Me}from"../chunks/scheduler.defa9a21.js";import{S as He,i as We,g as l,s as o,r as c,A as qe,h as i,f as t,c as r,j as $,u as p,x as D,k as w,y as n,a as s,v as _,d as m,t as u,w as f}from"../chunks/index.fe795e71.js";import{D as H}from"../chunks/Docstring.07f3d703.js";import{H as Y,E as Re}from"../chunks/EditOnGithub.0f575778.js";function Ve(Ce){let b,Z,Q,ee,F,te,C,ae,y,T,he,W,Te="Enables RAM efficient loading of Hugging Face models for FSDP in the environment.",oe,k,re,v,N,be,q,ke="Disables RAM efficient loading of Hugging Face models for FSDP in the environment.",ne,U,le,g,O,ye,R,Ne=`Merge the weights from sharded FSDP model checkpoints into a single combined checkpoint. Should be used if
<code>SHARDED_STATE_DICT</code> was used for the model. Weights will be saved to <code>{output_path}/model.safetensors</code> if
<code>safe_serialization</code> else <code>pytorch_model.bin</code>.`,ve,V,Ue="Note: this is a CPU-bound process.",ie,E,se,d,L,$e,B,Oe="This plugin is used to enable fully sharded data parallelism.",we,P,z,Pe,G,Ee=`Given <code>model</code>, creates an <code>auto_wrap_policy</code> baesd on the passed in policy and if we can use the
<code>transformer_cls_to_wrap</code>`,Se,S,A,xe,j,Le="Sets the mixed precision policy for FSDP",De,x,I,Fe,J,ze="Set the state dict config based on the <code>StateDictType</code>.",de,M,ce,X,pe;return F=new Y({props:{title:"Fully Sharded Data Parallel utilities",local:"fully-sharded-data-parallel-utilities",headingTag:"h1"}}),C=new Y({props:{title:"enable_fsdp_ram_efficient_loading",local:"accelerate.utils.enable_fsdp_ram_efficient_loading",headingTag:"h2"}}),T=new H({props:{name:"accelerate.utils.enable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.enable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/fsdp_utils.py#L31"}}),k=new Y({props:{title:"disable_fsdp_ram_efficient_loading",local:"accelerate.utils.disable_fsdp_ram_efficient_loading",headingTag:"h2"}}),N=new H({props:{name:"accelerate.utils.disable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.disable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/fsdp_utils.py#L41"}}),U=new Y({props:{title:"merge_fsdp_weights",local:"accelerate.utils.merge_fsdp_weights",headingTag:"h2"}}),O=new H({props:{name:"accelerate.utils.merge_fsdp_weights",anchor:"accelerate.utils.merge_fsdp_weights",parameters:[{name:"checkpoint_dir",val:": str"},{name:"output_path",val:": str"},{name:"safe_serialization",val:": bool = True"},{name:"remove_checkpoint_dir",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.utils.merge_fsdp_weights.checkpoint_dir",description:`<strong>checkpoint_dir</strong> (<code>str</code>) &#x2014;
The directory containing the FSDP checkpoints (can be either the model or optimizer).`,name:"checkpoint_dir"},{anchor:"accelerate.utils.merge_fsdp_weights.output_path",description:`<strong>output_path</strong> (<code>str</code>) &#x2014;
The path to save the merged checkpoint.`,name:"output_path"},{anchor:"accelerate.utils.merge_fsdp_weights.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to save the merged weights with safetensors (recommended).`,name:"safe_serialization"},{anchor:"accelerate.utils.merge_fsdp_weights.remove_checkpoint_dir",description:`<strong>remove_checkpoint_dir</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to remove the checkpoint directory after merging.`,name:"remove_checkpoint_dir"}],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/fsdp_utils.py#L275"}}),E=new Y({props:{title:"FullyShardedDataParallelPlugin",local:"accelerate.FullyShardedDataParallelPlugin",headingTag:"h2"}}),L=new H({props:{name:"class accelerate.FullyShardedDataParallelPlugin",anchor:"accelerate.FullyShardedDataParallelPlugin",parameters:[{name:"sharding_strategy",val:": Union = None"},{name:"backward_prefetch",val:": Union = None"},{name:"mixed_precision_policy",val:": Union = None"},{name:"auto_wrap_policy",val:": Union = None"},{name:"cpu_offload",val:": Union = None"},{name:"ignored_modules",val:": Optional = None"},{name:"state_dict_type",val:": Union = None"},{name:"state_dict_config",val:": Union = None"},{name:"optim_state_dict_config",val:": Union = None"},{name:"limit_all_gathers",val:": bool = True"},{name:"use_orig_params",val:": bool = None"},{name:"param_init_fn",val:": Optional = None"},{name:"sync_module_states",val:": bool = None"},{name:"forward_prefetch",val:": bool = None"},{name:"activation_checkpointing",val:": bool = None"},{name:"cpu_ram_efficient_loading",val:": bool = None"},{name:"transformer_cls_names_to_wrap",val:": Optional = None"},{name:"min_num_params",val:": Optional = None"}],parametersDescription:[{anchor:"accelerate.FullyShardedDataParallelPlugin.sharding_strategy",description:`<strong>sharding_strategy</strong> (<code>Union[str, torch.distributed.fsdp.ShardingStrategy]</code>, defaults to <code>&apos;FULL_SHARD&apos;</code>) &#x2014;
Sharding strategy to use. Should be either a <code>str</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.ShardingStrategy</code>.`,name:"sharding_strategy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.backward_prefetch",description:`<strong>backward_prefetch</strong> (<code>Union[str, torch.distributed.fsdp.BackwardPrefetch]</code>, defaults to <code>&apos;NO_PREFETCH&apos;</code>) &#x2014;
Backward prefetch strategy to use. Should be either a <code>str</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.BackwardPrefetch</code>.`,name:"backward_prefetch"},{anchor:"accelerate.FullyShardedDataParallelPlugin.mixed_precision_policy",description:`<strong>mixed_precision_policy</strong> (<code>Optional[Union[dict, torch.distributed.fsdp.MixedPrecision]]</code>, defaults to <code>None</code>) &#x2014;
A config to enable mixed precision training with FullyShardedDataParallel. If passing in a <code>dict</code>, it
should have the following keys: <code>param_dtype</code>, <code>reduce_dtype</code>, and <code>buffer_dtype</code>.`,name:"mixed_precision_policy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.auto_wrap_policy",description:"<strong>auto_wrap_policy</strong> (<code>Optional(Union[Callable, Literal[&quot;transformer_based_wrap&quot;, &quot;size_based_wrap&quot;, &quot;no_wrap&quot;]]), defaults to </code>NO_WRAP<code>) -- A callable or string specifying a policy to recursively wrap layers with FSDP. If a string, it must be one of </code>transformer_based_wrap<code>, </code>size_based_wrap<code>, or </code>no_wrap<code>. See </code>torch.distributed.fsdp.wrap.size_based_wrap_policy` for a direction on what it should look like.",name:"auto_wrap_policy"},{anchor:"accelerate.FullyShardedDataParallelPlugin.cpu_offload",description:`<strong>cpu_offload</strong> (<code>Union[bool, torch.distributed.fsdp.CPUOffload]</code>, defaults to <code>False</code>) &#x2014;
Whether to offload parameters to CPU. Should be either a <code>bool</code> or an instance of
<code>torch.distributed.fsdp.fully_sharded_data_parallel.CPUOffload</code>.`,name:"cpu_offload"},{anchor:"accelerate.FullyShardedDataParallelPlugin.ignored_modules",description:`<strong>ignored_modules</strong> (<code>Optional[Iterable[torch.nn.Module]]</code>, defaults to <code>None</code>) &#x2014;
A list of modules to ignore when wrapping with FSDP.`,name:"ignored_modules"},{anchor:"accelerate.FullyShardedDataParallelPlugin.state_dict_type",description:`<strong>state_dict_type</strong> (<code>Union[str, torch.distributed.fsdp.StateDictType]</code>, defaults to <code>&apos;FULL_STATE_DICT&apos;</code>) &#x2014;
State dict type to use. If a string, it must be one of <code>full_state_dict</code>, <code>local_state_dict</code>, or
<code>sharded_state_dict</code>.`,name:"state_dict_type"},{anchor:"accelerate.FullyShardedDataParallelPlugin.state_dict_config",description:`<strong>state_dict_config</strong> (<code>Optional[Union[torch.distributed.fsdp.FullStateDictConfig, torch.distributed.fsdp.ShardedStateDictConfig]</code>, defaults to <code>None</code>) &#x2014;
State dict config to use. Is determined based on the <code>state_dict_type</code> if not passed in.`,name:"state_dict_config"},{anchor:"accelerate.FullyShardedDataParallelPlugin.optim_state_dict_config",description:`<strong>optim_state_dict_config</strong> (<code>Optional[Union[torch.distributed.fsdp.FullOptimStateDictConfig, torch.distributed.fsdp.ShardedOptimStateDictConfig]</code>, defaults to <code>None</code>) &#x2014;
Optim state dict config to use. Is determined based on the <code>state_dict_type</code> if not passed in.`,name:"optim_state_dict_config"},{anchor:"accelerate.FullyShardedDataParallelPlugin.limit_all_gathers",description:`<strong>limit_all_gathers</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to have FSDP explicitly synchronizes the CPU thread to prevent too many in-flight all-gathers. This
bool only affects the sharded strategies that schedule all-gathers. Enabling this can help lower the number
of CUDA malloc retries.`,name:"limit_all_gathers"},{anchor:"accelerate.FullyShardedDataParallelPlugin.use_orig_params",description:`<strong>use_orig_params</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the original parameters for the optimizer.`,name:"use_orig_params"},{anchor:"accelerate.FullyShardedDataParallelPlugin.param_init_fn",description:`<strong>param_init_fn</strong> (<code>Optional[Callable[[torch.nn.Module], None]</code>, defaults to <code>None</code>) &#x2014;
A <code>Callable[torch.nn.Module] -&gt; None</code> that specifies how modules that are currently on the meta device
should be initialized onto an actual device. Only applicable when <code>sync_module_states</code> is <code>True</code>. By
default is a <code>lambda</code> which calls <code>to_empty</code> on the module.`,name:"param_init_fn"},{anchor:"accelerate.FullyShardedDataParallelPlugin.sync_module_states",description:`<strong>sync_module_states</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether each individually wrapped FSDP unit should broadcast module parameters from rank 0 to ensure they
are the same across all ranks after initialization. Defaults to <code>False</code> unless <code>cpu_ram_efficient_loading</code>
is <code>True</code>, then will be forcibly enabled.`,name:"sync_module_states"},{anchor:"accelerate.FullyShardedDataParallelPlugin.forward_prefetch",description:`<strong>forward_prefetch</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to have FSDP explicitly prefetches the next upcoming all-gather while executing in the forward
pass. only use with Static graphs.`,name:"forward_prefetch"},{anchor:"accelerate.FullyShardedDataParallelPlugin.activation_checkpointing",description:`<strong>activation_checkpointing</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
A technique to reduce memory usage by clearing activations of certain layers and recomputing them during a
backward pass. Effectively, this trades extra computation time for reduced memory usage.`,name:"activation_checkpointing"},{anchor:"accelerate.FullyShardedDataParallelPlugin.cpu_ram_efficient_loading",description:`<strong>cpu_ram_efficient_loading</strong> (<code>bool</code>, defaults to <code>None</code>) &#x2014;
If True, only the first process loads the pretrained model checkoint while all other processes have empty
weights. Only applicable for Transformers. When using this, <code>sync_module_states</code> needs to be <code>True</code>.`,name:"cpu_ram_efficient_loading"},{anchor:"accelerate.FullyShardedDataParallelPlugin.transformer_cls_names_to_wrap",description:`<strong>transformer_cls_names_to_wrap</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
A list of transformer layer class names to wrap. Only applicable when <code>auto_wrap_policy</code> is
<code>transformer_based_wrap</code>.`,name:"transformer_cls_names_to_wrap"},{anchor:"accelerate.FullyShardedDataParallelPlugin.min_num_params",description:`<strong>min_num_params</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
The minimum number of parameters a module must have to be wrapped. Only applicable when <code>auto_wrap_policy</code>
is <code>size_based_wrap</code>.`,name:"min_num_params"}],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/dataclasses.py#L1403"}}),z=new H({props:{name:"set_auto_wrap_policy",anchor:"accelerate.FullyShardedDataParallelPlugin.set_auto_wrap_policy",parameters:[{name:"model",val:""}],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/dataclasses.py#L1737"}}),A=new H({props:{name:"set_mixed_precision",anchor:"accelerate.FullyShardedDataParallelPlugin.set_mixed_precision",parameters:[{name:"mixed_precision",val:""},{name:"buffer_autocast",val:" = False"},{name:"override",val:" = False"}],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/dataclasses.py#L1768"}}),I=new H({props:{name:"set_state_dict_type",anchor:"accelerate.FullyShardedDataParallelPlugin.set_state_dict_type",parameters:[{name:"state_dict_type",val:" = None"}],source:"https://github.com/huggingface/accelerate/blob/v1.1.0/src/accelerate/utils/dataclasses.py#L1701"}}),M=new Re({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/package_reference/fsdp.md"}}),{c(){b=l("meta"),Z=o(),Q=l("p"),ee=o(),c(F.$$.fragment),te=o(),c(C.$$.fragment),ae=o(),y=l("div"),c(T.$$.fragment),he=o(),W=l("p"),W.textContent=Te,oe=o(),c(k.$$.fragment),re=o(),v=l("div"),c(N.$$.fragment),be=o(),q=l("p"),q.textContent=ke,ne=o(),c(U.$$.fragment),le=o(),g=l("div"),c(O.$$.fragment),ye=o(),R=l("p"),R.innerHTML=Ne,ve=o(),V=l("p"),V.textContent=Ue,ie=o(),c(E.$$.fragment),se=o(),d=l("div"),c(L.$$.fragment),$e=o(),B=l("p"),B.textContent=Oe,we=o(),P=l("div"),c(z.$$.fragment),Pe=o(),G=l("p"),G.innerHTML=Ee,Se=o(),S=l("div"),c(A.$$.fragment),xe=o(),j=l("p"),j.textContent=Le,De=o(),x=l("div"),c(I.$$.fragment),Fe=o(),J=l("p"),J.innerHTML=ze,de=o(),c(M.$$.fragment),ce=o(),X=l("p"),this.h()},l(e){const a=qe("svelte-u9bgzb",document.head);b=i(a,"META",{name:!0,content:!0}),a.forEach(t),Z=r(e),Q=i(e,"P",{}),$(Q).forEach(t),ee=r(e),p(F.$$.fragment,e),te=r(e),p(C.$$.fragment,e),ae=r(e),y=i(e,"DIV",{class:!0});var _e=$(y);p(T.$$.fragment,_e),he=r(_e),W=i(_e,"P",{"data-svelte-h":!0}),D(W)!=="svelte-1lsbcnp"&&(W.textContent=Te),_e.forEach(t),oe=r(e),p(k.$$.fragment,e),re=r(e),v=i(e,"DIV",{class:!0});var me=$(v);p(N.$$.fragment,me),be=r(me),q=i(me,"P",{"data-svelte-h":!0}),D(q)!=="svelte-o9zxg8"&&(q.textContent=ke),me.forEach(t),ne=r(e),p(U.$$.fragment,e),le=r(e),g=i(e,"DIV",{class:!0});var K=$(g);p(O.$$.fragment,K),ye=r(K),R=i(K,"P",{"data-svelte-h":!0}),D(R)!=="svelte-lbcivn"&&(R.innerHTML=Ne),ve=r(K),V=i(K,"P",{"data-svelte-h":!0}),D(V)!=="svelte-s693kt"&&(V.textContent=Ue),K.forEach(t),ie=r(e),p(E.$$.fragment,e),se=r(e),d=i(e,"DIV",{class:!0});var h=$(d);p(L.$$.fragment,h),$e=r(h),B=i(h,"P",{"data-svelte-h":!0}),D(B)!=="svelte-da89af"&&(B.textContent=Oe),we=r(h),P=i(h,"DIV",{class:!0});var ue=$(P);p(z.$$.fragment,ue),Pe=r(ue),G=i(ue,"P",{"data-svelte-h":!0}),D(G)!=="svelte-i24l23"&&(G.innerHTML=Ee),ue.forEach(t),Se=r(h),S=i(h,"DIV",{class:!0});var fe=$(S);p(A.$$.fragment,fe),xe=r(fe),j=i(fe,"P",{"data-svelte-h":!0}),D(j)!=="svelte-1oofbyv"&&(j.textContent=Le),fe.forEach(t),De=r(h),x=i(h,"DIV",{class:!0});var ge=$(x);p(I.$$.fragment,ge),Fe=r(ge),J=i(ge,"P",{"data-svelte-h":!0}),D(J)!=="svelte-1ugzx3"&&(J.innerHTML=ze),ge.forEach(t),h.forEach(t),de=r(e),p(M.$$.fragment,e),ce=r(e),X=i(e,"P",{}),$(X).forEach(t),this.h()},h(){w(b,"name","hf:doc:metadata"),w(b,"content",Be),w(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){n(document.head,b),s(e,Z,a),s(e,Q,a),s(e,ee,a),_(F,e,a),s(e,te,a),_(C,e,a),s(e,ae,a),s(e,y,a),_(T,y,null),n(y,he),n(y,W),s(e,oe,a),_(k,e,a),s(e,re,a),s(e,v,a),_(N,v,null),n(v,be),n(v,q),s(e,ne,a),_(U,e,a),s(e,le,a),s(e,g,a),_(O,g,null),n(g,ye),n(g,R),n(g,ve),n(g,V),s(e,ie,a),_(E,e,a),s(e,se,a),s(e,d,a),_(L,d,null),n(d,$e),n(d,B),n(d,we),n(d,P),_(z,P,null),n(P,Pe),n(P,G),n(d,Se),n(d,S),_(A,S,null),n(S,xe),n(S,j),n(d,De),n(d,x),_(I,x,null),n(x,Fe),n(x,J),s(e,de,a),_(M,e,a),s(e,ce,a),s(e,X,a),pe=!0},p:Ie,i(e){pe||(m(F.$$.fragment,e),m(C.$$.fragment,e),m(T.$$.fragment,e),m(k.$$.fragment,e),m(N.$$.fragment,e),m(U.$$.fragment,e),m(O.$$.fragment,e),m(E.$$.fragment,e),m(L.$$.fragment,e),m(z.$$.fragment,e),m(A.$$.fragment,e),m(I.$$.fragment,e),m(M.$$.fragment,e),pe=!0)},o(e){u(F.$$.fragment,e),u(C.$$.fragment,e),u(T.$$.fragment,e),u(k.$$.fragment,e),u(N.$$.fragment,e),u(U.$$.fragment,e),u(O.$$.fragment,e),u(E.$$.fragment,e),u(L.$$.fragment,e),u(z.$$.fragment,e),u(A.$$.fragment,e),u(I.$$.fragment,e),u(M.$$.fragment,e),pe=!1},d(e){e&&(t(Z),t(Q),t(ee),t(te),t(ae),t(y),t(oe),t(re),t(v),t(ne),t(le),t(g),t(ie),t(se),t(d),t(de),t(ce),t(X)),t(b),f(F,e),f(C,e),f(T),f(k,e),f(N),f(U,e),f(O),f(E,e),f(L),f(z),f(A),f(I),f(M,e)}}}const Be='{"title":"Fully Sharded Data Parallel utilities","local":"fully-sharded-data-parallel-utilities","sections":[{"title":"enable_fsdp_ram_efficient_loading","local":"accelerate.utils.enable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"disable_fsdp_ram_efficient_loading","local":"accelerate.utils.disable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"merge_fsdp_weights","local":"accelerate.utils.merge_fsdp_weights","sections":[],"depth":2},{"title":"FullyShardedDataParallelPlugin","local":"accelerate.FullyShardedDataParallelPlugin","sections":[],"depth":2}],"depth":1}';function Ge(Ce){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends He{constructor(b){super(),We(this,b,Ge,Ve,Ae,{})}}export{Xe as component};
